version: "3.8"


x-database-env: &database-env
  POSTGRES_DB: keycloak
  POSTGRES_USER: keycloak
  POSTGRES_PASSWORD: password

x-keycloak-env: &keycloak-env
  DB_VENDOR: POSTGRES
  DB_ADDR: keycloak-database-demo
  DB_DATABASE: keycloak
  DB_USER: keycloak
  DB_SCHEMA: public
  DB_PASSWORD: password
  KEYCLOAK_USER: admin
  KEYCLOAK_PASSWORD: kcpassword
  KEYCLOAK_LOGLEVEL: DEBUG
  KEYCLOAK_IMPORT: /opt/realm.json -Dkeycloak.profile.feature.upload_scripts=enabled
  ROOT_LOGLEVEL: DEBUG

volumes:
  cloud_data:
  keycloak_data:

services:
  cloud-database:
    image: postgres:14.4-alpine
    healthcheck:
      test: [ "CMD-SHELL","pg_isready","-U","cloudadmin" ]
      interval: 10s
      timeout: 5s
      retries: 3
    restart: unless-stopped
    container_name: cloud-database
    ports:
      - "5252:5432"
    environment:
      PGDATA: /var/lib/postgresql/data
      POSTGRES_DB: cloud_db
      POSTGRES_USER: cloudadmin
      POSTGRES_PASSWORD: secretpassword
    volumes:
      - cloud_data:/var/lib/postgresql/data
  keycloak-database:
    image: postgres:14.4-alpine
    restart: unless-stopped
    volumes:
      - keycloak_data:/var/lib/postgresql/data
    container_name: keycloak-database-demo
    healthcheck:
      test: [ "CMD","pg_isready","-U","keycloak" ]
      interval: 10s
      timeout: 5s
      retries: 3
    environment:
      <<: *database-env
    ports:
      - "5555:5432"
  keycloak-service:
    image: jboss/keycloak:16.1.1
    restart: unless-stopped
    container_name: keycloak-server-demo
    volumes:
      - ./keycloak/realm.json:/opt/realm.json
    environment:
      <<: *keycloak-env
    ports:
      - "8800:8080"
      - "8443:8443"
    depends_on:
      - keycloak-database
    healthcheck:
      test:
        [
          "CMD",
          "curl",
          "--fail",
          "http://localhost:8080/auth/realms/master"
        ]
      interval: 20s
      timeout: 3s
      start_period: 10s
      retries: 3